# **RPMA: Remote Persistent Memory Access**

[![Travis build status](https://travis-ci.org/pmem/rpma.svg?branch=master)](https://travis-ci.org/pmem/rpma)
[![GHA build status](https://github.com/pmem/rpma/workflows/RPMA/badge.svg?branch=master)](https://github.com/pmem/rpma/actions)
[![librpma version](https://img.shields.io/github/tag/pmem/rpma.svg)](https://github.com/pmem/rpma/releases/latest)
[![Coverage Status](https://codecov.io/github/pmem/rpma/coverage.svg?branch=master)](https://codecov.io/gh/pmem/rpma/branch/master)

The **Remote Persistent Memory Access (RPMA)** is a C library to simplify accessing persistent memory devices on remote hosts over **Remote Direct Memory Access (RDMA)**. For more information, see
[pmem.io](https://pmem.io).


## Contact Us

For more information on this library, contact
Tomasz Gromadzki (tomasz.gromadzki@intel.com),
Jan Michalski (jan.m.michalski@intel.com),
Piotr Balcer (piotr.balcer@intel.com),
Chet Douglas (chet.r.douglas@intel.com), or post to our
[Google group](https://groups.google.com/group/pmem).

## More Info

[Persistent Memory Over Traditional RDMA White Paper - Part 1](https://software.intel.com/content/www/us/en/develop/articles/persistent-memory-replication-over-traditional-rdma-part-1-understanding-remote-persistent.html) - which describes a technology behind RPMA. **Note:** Parts 2-4 relates directly to librpmem library which is a predecessor of librpma. So parts 2-4 do not relate exactly to how librpma works.
